#include "GUI.h"
#include "wm.h"
#include "DIALOG.h"
#include "stdio.h"
#define ID_WINDOW_0 (GUI_ID_USER + 0x00)
#define ID_BUTTON_0 (GUI_ID_USER + 0x01)
#define ID_BUTTON_1 (GUI_ID_USER + 0x02)
WM_HWIN CreatePage1Window(void);
WM_HWIN CreatePage2Window(void);
    
extern GUI_CONST_STORAGE GUI_BITMAP bmCamera64x64;
extern GUI_CONST_STORAGE GUI_BITMAP bmSound64x64;
extern volatile int g_enable_Touch;    
int ts_calibrate(int xsize, int ysize);

static const GUI_WIDGET_CREATE_INFO _aDialogCreate[] = {
  { WINDOW_CreateIndirect, "Home", ID_WINDOW_0, 0, 0, 320, 240, 0, 0x0, 0 },
  { BUTTON_CreateIndirect, "Page1", ID_BUTTON_0, 64, 88, 64, 64, 0, 0x0, 0 },
  { BUTTON_CreateIndirect, "Page2", ID_BUTTON_1, 192, 88, 64, 64, 0, 0x0, 0 },
};

static void _cbButton0(WM_MESSAGE * pMsg) 
{
     switch(pMsg->MsgId)
     {
         case WM_PAINT:
               GUI_DrawBitmap(&bmCamera64x64,0,0);
              break;
         default:
              BUTTON_Callback(pMsg);
     }
}

static void _cbButton1(WM_MESSAGE * pMsg) 
{
     switch(pMsg->MsgId)
     {
         case WM_PAINT:
               GUI_DrawBitmap(&bmSound64x64,0,0);
              break;
         default:
              BUTTON_Callback(pMsg);
     }
}

static void _cbHomeWindow(WM_MESSAGE * pMsg) {
    WM_HWIN hItem, hWin;
    int     NCode;
    int     Id;
    hWin = pMsg->hWin;
    
    switch (pMsg->MsgId) {
    case WM_INIT_DIALOG:

        hItem = WM_GetDialogItem(pMsg->hWin, ID_BUTTON_0);            
        WM_SetCallback(hItem,_cbButton0); 
    
        hItem = WM_GetDialogItem(pMsg->hWin, ID_BUTTON_1);           
        WM_SetCallback(hItem,_cbButton1);     
    break;

    case WM_PAINT:
        GUI_SetBkColor(GUI_BLUE);
        GUI_Clear(); 
    
        GUI_SetTextMode(GUI_TM_TRANS);
        GUI_SetTextAlign(GUI_TA_HCENTER | GUI_TA_VCENTER);
        GUI_SetFont(GUI_FONT_24B_1);        
        GUI_SetColor(GUI_RED);
        GUI_DispStringHCenterAt("Home is BLUE" , 160, 30);    
    break;    
  
    case WM_NOTIFY_PARENT:
        Id    = WM_GetId(pMsg->hWinSrc);
        NCode = pMsg->Data.v;
        switch(Id) {
        case ID_BUTTON_0: // Notifications sent by 'Button'
            switch(NCode) {
            case WM_NOTIFICATION_CLICKED:
                __nop();
            break;
            case WM_NOTIFICATION_RELEASED:
                WM_DeleteWindow(hWin);
                CreatePage1Window();
            break;
            }
            break;
            
        case ID_BUTTON_1: // Notifications sent by 'Button'
            switch(NCode) {
            case WM_NOTIFICATION_CLICKED:
                __nop();
            break;
            case WM_NOTIFICATION_RELEASED:
                WM_DeleteWindow(hWin);
                CreatePage2Window();
            break;
            }
            break;          
    }
    break;
    default:
        WM_DefaultProc(pMsg);
    break;
    }
}

WM_HWIN Create_HmoeWindow(void)
{
    WM_HWIN hWin;
    hWin = GUI_CreateDialogBox(_aDialogCreate, GUI_COUNTOF(_aDialogCreate), _cbHomeWindow, WM_HBKWIN, 0, 0);
    return hWin;
}

void GUI_Main(void)
{
    GUI_Init();
    ts_calibrate(320, 240);
    g_enable_Touch = 1;
    WM_SetCreateFlags(WM_CF_MEMDEV);
    WM_MULTIBUF_Enable(1);
    GUI_SetTextMode(GUI_TM_TRANS);
    Create_HmoeWindow();
    while (1)
    {
        GUI_Exec();
    }
}


